#property copyright "Copyright  2009, Putra"
#property link      "http://putra.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 RoyalBlue
#property indicator_color3 Red
#property indicator_color4 RoyalBlue

//-----
//datetime nextCandle;

//---- parameters
int MaMetod  = 1;
int MaPeriod = 15;

extern string trend;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM, 0, 2, Orange);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM, 0, 2, Green);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM, 0, 3, Red);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM, 0, 3, RoyalBlue);
   SetIndexBuffer(3, ExtMapBuffer4);
//----
   SetIndexDrawBegin(0,5);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double openBar1, closeBar1, highBar1, lowBar1;
   string openBar, closeBar, highBar, lowBar;
   string colorBar1, colorBar2;  
  
   double maOpen, maClose, maLow, maHigh;
   double haOpen, haHigh, haLow, haClose;
   
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
     {
      maOpen=iMA(NULL,0,MaPeriod,0,MaMetod,MODE_OPEN,pos);
      maClose=iMA(NULL,0,MaPeriod,0,MaMetod,MODE_CLOSE,pos);
      maLow=iMA(NULL,0,MaPeriod,0,MaMetod,MODE_LOW,pos);
      maHigh=iMA(NULL,0,MaPeriod,0,MaMetod,MODE_HIGH,pos);

      haOpen=(ExtMapBuffer3[pos+1]+ExtMapBuffer4[pos+1])/2;
      haClose=(maOpen+maHigh+maLow+maClose)/4;
      haHigh=MathMax(maHigh, MathMax(haOpen, haClose));
      haLow=MathMin(maLow, MathMin(haOpen, haClose));
      if (haOpen<haClose) 
        {
         ExtMapBuffer1[pos]=haLow;
         ExtMapBuffer2[pos]=haHigh;
        } 
      else
        {
         ExtMapBuffer1[pos]=haHigh;
         ExtMapBuffer2[pos]=haLow;
        } 
      ExtMapBuffer3[pos]=haOpen;  
      ExtMapBuffer4[pos]=haClose;  
      
 //--------------------------------Get 2 latest bar Color from Chart-----------------     
       
      if(ExtMapBuffer3[0] > ExtMapBuffer3[1])
      {
         colorBar1 = "Blue";
      }
      else
      {
         colorBar1 = "Red";
      } 
     
      if(ExtMapBuffer3[1] > ExtMapBuffer3[2])
      {
         colorBar2 = "Blue";
      }
      else
      {
         colorBar2 = "Red";
      }  
 	   pos--;
    }//end of while

//--------------------------------Compare 2 latest color bar-------------------------------
      if(colorBar1 == "Red" && colorBar2 == "Blue")
      {
         trend = "DOWN";
      }
      else if(colorBar2 == "Red" && colorBar1 == "Blue")
      {
         trend = "UP";
      }
      else
      {
         trend = "-SAME-";
      }
      
         ObjectDelete("tren");  
         if(ObjectFind("tren") != 0)
         {
            ObjectCreate("tren", OBJ_TEXT, 0, Time[0], Close[0]- 0.0007);
            ObjectSetText("tren", "                  Trend-"+trend, 11, "Verdana", Green);
         }
         else
         {
            ObjectMove("tren", 0, Time[0], Close[0]- 0.0007);
         }
   //}
   return(0);
  }
//+------------------------------------------------------------------+


